//+------------------------------------------------------------------+
//|                                              FX Loophole Pro.mq4 |
//|                                                 Copyright  2010 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010"
#property link      ""

double TP,SL,MAXLOT,MINLOT;
int  i,myBars,barra;
bool UseNormalize1Double=false;
int NumDigitosPar;

//--------- //--------- //--------- //--------- //--------- //--------- //--------- //--------- 
//---------                      Settings                                             //---------
//--------- //--------- //--------- //--------- //--------- //--------- //--------- //--------- 
extern double  Lots                   = 0.10;//  Lots Value 
extern int     StopLoss               = 155;  //  StopLoss 
extern int     TakeProfit             = 5;  //  TakeProfit 

extern string  EAName                 = "FXLoopholeX2"; //  Name to show into comments Orders
extern int     MagicNumber            = 1234;      //  Magic Number - A dif. number for each   Pair

extern bool    ECN                    = true; // if True, it means that your broker is ECN
 
extern double  PercentRisk            = 0 ; //If different of "0" , it means Percentual. In other words, the EA will get this value, (e.g 3 - %) 
                                            //and calculate according your StopLoss variable , the new lots value to put in Risk.
                                            //if = 0 , lots value will be Lots variable .
 extern bool  UseHourTrade = True;        // ---------------- 5
 extern int  FromHourTrade = 18;            // ---------------- 6
 extern int  ToHourTrade = 24;

//--------- //--------- //--------- //--------- //--------- //--------- //--------- //--------- 

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){

if (MarketInfo(Symbol(),MODE_MINLOT)==0.1) UseNormalize1Double=true;
MINLOT=MarketInfo(Symbol(),MODE_MINLOT);
MAXLOT=MarketInfo(Symbol(),MODE_MAXLOT);

      int Digitos = MarketInfo(Symbol(), MODE_DIGITS);
      if (Digitos == 2 || Digitos == 4 ) NumDigitosPar = 1;
      if (Digitos == 3 || Digitos == 5 ) NumDigitosPar = 10;
      
   if (StopLoss > 0.0) StopLoss = NormalizeDouble(StopLoss * NumDigitosPar , Digits);
      else StopLoss = 0;
   if (TakeProfit > 0.0) TakeProfit = NormalizeDouble(TakeProfit * NumDigitosPar , Digits);
      else TakeProfit = 0;
      
  
return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{  
return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                          
//+------------------------------------------------------------------+
int start(){

 if (UseHourTrade){
        if(!(Hour()>=FromHourTrade&&Hour()<=ToHourTrade)){
           Comment("Non-Trading Hours!");
           return(0);
         }
       }

   if(isNewBar())
    if  (!OE(MagicNumber,99,true,false,"99"))       CheckEntry();
 
//if (debug) comentarios();
return(0);
} 

//----------- Inicio das VOIDS --------------------------------------------------------------------------------------
//----------- Inicio das VOIDS --------------------------------------------------------------------------------------
//----------- Inicio das VOIDS --------------------------------------------------------------------------------------

void CheckEntry(){
             
if (Check(0))
   if (Check(0))
   {
   Print(" Sending Buy Order.. ");
   SendOrder(0);
   return;
   }
              
              
if (Check(1))
   if (Check(1))
   {               
   Print(" Sending Sell Order.. ");
   SendOrder(1);
   }
              
}//

bool OE(int Magic,int tipo,bool any=false,bool anyAgendada=false,string comentario=""){
int Total =    OrdersTotal();
            
            if (Total!=0)
            for (int i=0;i<Total;i++) {
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);                                               
            
               if  (OrderMagicNumber()==Magic || Magic==99 ){
                  //achar um determinado tipo
                  if (  (tipo==OrderType() || tipo==99) && OrderSymbol()==Symbol() &&  (OrderComment()==comentario|| comentario=="99")  )  return(true);
                
                  //achar any/qualquer tipo = true
                  if ( any && OrderSymbol()==Symbol() )  return(true);
                
                  //achar qq tipo de agendada = true
                  if ( (anyAgendada) && OrderSymbol()==Symbol()  && OrderType()>1 )
                  return(true);
               }
            }
return(false);
}

double GetLots(double SLinPips ,double PercentRisk,double DefaultLots){
double lotsl;

double TamLote=(AccountEquity()*PercentRisk)/100; 

if (SLinPips==0){Print(" Returning Default Lots.. SLinPips cannot be 0 ");return(DefaultLots);}

//--se 5digits
int NumDigitosPar;
   int Digitos = MarketInfo(Symbol(), MODE_DIGITS);
   
   if (Digitos == 3 || Digitos == 5 ) SLinPips /=10;
//--

double RiskPerAverage=TamLote/(SLinPips); //2,0

if ((MarketInfo(Symbol(),MODE_LOTSIZE))==100000) lotsl=(RiskPerAverage*0.10);//0,2
if ((MarketInfo(Symbol(),MODE_LOTSIZE))==10000)  lotsl=(RiskPerAverage*1.00);//0,2

//Print(" TamLote: ",TamLote," RiskPerAverage: ",RiskPerAverage," lotsl: ",lotsl," UseNormalize1Double: ",UseNormalize1Double);

if (UseNormalize1Double)lotsl=NormalizeDouble(lotsl,1); // faz um arrendodamento

return(lotsl);
}



void SendOrder(int bs){
double p,lt,price,t,tp,sl;
int erro;

       if (PercentRisk!=0 && StopLoss!=0)  lt=GetLots(StopLoss,PercentRisk,Lots);
         else                              lt=Lots;
         
if (bs==0){
  int count=0;
  int Ticket=-99;
     
          if (StopLoss==0)sl=0;else sl=Ask-(StopLoss*Point);
          if (TakeProfit==0)tp=0;else tp=Ask+(TakeProfit*Point);

          if (ECN){sl=0;tp=0;}
         
         
         while(Ticket<0) 
         {
            RefreshRates();
           
              Ticket=OrderSend(Symbol(),OP_BUY,lt,NormalizeDouble(Ask,Digits),sl,tp,0,EAName,MagicNumber,0,Blue);

                  if(Ticket<0)
                  {
                  Print("erro OP_BUY = ",erro," sl= ",sl," tp = ",tp," lt = ",lt," texto = ",0," ask = ",Ask," GetLastError =  ",GetLastError());
                  count++;
                  }
                  
                  if(Ticket>0 && ECN)
                  {
                      
                  if (StopLoss==0)sl=0;else sl=Ask-(StopLoss*Point);
                  if (TakeProfit==0)tp=0;else tp=Ask+(TakeProfit*Point);
                  
                              if (sl!=0 || tp!=0)
                              {
                              OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES);
                                if (!OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,Green))
                                     Print("Error modifying OP_BUY  OrderTicket :  ",OrderTicket()," TP: ",TP," bs: ",bs," tp = ",tp," EP = ",0," SL = ",OrderStopLoss(),"  TP = ",OrderTakeProfit()," OrderTicket() ",OrderTicket()," OrderStop change to  = ",sl);
                                   else
                                      Print(" OK!  OP_BUYt  = ",bs," tp = ",tp," EP = ",0," NEWSL = ",sl,"  TP = ",OrderTakeProfit()," OrderTicket() ",OrderTicket()," OrderStop change to  = ",sl);
                              }
                     
                  }
                  
             while (IsTradeContextBusy()) Sleep(250);
          if (count>10)return(0);   
         }
}


   if (bs==1) {
   Ticket=-1;
   count=0;
        
            while(Ticket<0)
            {
              RefreshRates();

                  if (StopLoss==0)sl=0;else sl=Bid+(StopLoss*Point);
                  if (TakeProfit==0)tp=0;else tp=Bid-(TakeProfit*Point);
                 
                  if (ECN){sl=0;tp=0;}

              
              Ticket=OrderSend(Symbol(),OP_SELL,lt,NormalizeDouble(Bid,Digits),sl,tp,0,EAName,MagicNumber,0,Red);
                 
                  if(Ticket<0)
                  {
                  Print("erro OP_SELL = ",erro," sl= ",sl," tp = ",tp," lt = ",lt," texto = ",0," ask = ",Ask," GetLastError =  ",GetLastError());
                  count++;
                  }
                  
                  if(Ticket>0 && ECN)
                  {
                  
                  if (StopLoss==0)sl=0;else sl=Bid+(StopLoss*Point);
                  if (TakeProfit==0)tp=0;else tp=Bid-(TakeProfit*Point);


                  
                              if (sl!=0 || tp!=0)
                              {
                              OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES);
                                if (!OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,Green))
                                     Print("Error modifying OP_SELL  OrderTicket :  ",OrderTicket()," TP: ",TP," bs: ",bs," tp = ",tp," EP = ",0," SL = ",OrderStopLoss(),"  TP = ",OrderTakeProfit()," OrderTicket() ",OrderTicket()," OrderStop change to  = ",sl);
                                   else
                                      Print(" OK!  OP_SELL  = ",bs," tp = ",tp," EP = ",0," NEWSL = ",sl,"  TP = ",OrderTakeProfit()," OrderTicket() ",OrderTicket()," OrderStop change to  = ",sl);
                              }
                  }
       
               while (IsTradeContextBusy()) Sleep(250);
            if (count>10)return(0);   
           }
          
    }

}//void

 
bool isNewBar()  {
   bool res=false;
   if (myBars!=Bars)
      {
      myBars=Bars;
      res=true;
      }
return(res);   
}


bool Check(int bs){
HideTestIndicators(true);
double STOc   = iStochastic(NULL,60,15,10,10,MODE_EMA,PRICE_CLOSE,MODE_MAIN,0);
double STOp   = iStochastic(NULL,60,15,10,10,MODE_EMA,PRICE_CLOSE,MODE_MAIN,1);
double iwpr= iWPR(NULL, 0,21, 0);
double sar1_1 =iSAR(NULL,0,0.05,0.5,1);
double sar1_0 =iSAR(NULL,0,0.05,0.5,0);
double osma=iOsMA(NULL,30,90,99,88,PRICE_OPEN,1);
double mom=iMomentum(NULL,60,31,PRICE_OPEN,0);
HideTestIndicators(false);
if (bs==0 && sar1_0 <= Ask&& sar1_1>sar1_0  && STOp<STOc&& STOc<80  && iwpr < -80.00 && mom>100 && osma>0)return(true);
if (bs==1 && sar1_0 >= Ask && sar1_1<sar1_0 && STOp>STOc && STOc>20 && iwpr > -20.00 && mom<100 && osma<0)return(true);


   Comment("\n", 
      "\n", " FX Loophole Pro  ---------- ",
      "\n", "...................................... ", 
      "\n", "Account Curency:", AccountCurrency(), 
      "\n", "Account free margin is " + DoubleToStr(AccountFreeMargin(), 2),  
      "\n", "...................................... ", 
      "\n", "High day price. ", MarketInfo(Symbol(), MODE_HIGH), 
      "\n", "Low day price.", MarketInfo(Symbol(), MODE_LOW), 
      "\n", "Currency Spread is ", MarketInfo(Symbol(), MODE_SPREAD), 
      "\n", "Current Ask Price is ", MarketInfo(Symbol(), MODE_ASK), 
      "\n", "Current Bid Price is ", MarketInfo(Symbol(), MODE_BID), 
      "\n", "Leverage 1:", AccountLeverage(), 
      "\n", "...................................... ", 
      "\n", "Account Balance:", AccountBalance(), 
      "\n", "...................................... ", 
   "\n", "Current Broker Time Is ", TimeToStr(TimeCurrent()));
   
   return(0);
   
 }